"{ Package: 'stx:libjava/tools' }"

LibraryDefinition subclass:#stx_libjava_tools
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_libjava_tools class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

mandatoryPreRequisites
    "list all required mandatory packages.
     Packages are mandatory, if they contain superclasses of the package's classes
     or classes which are extended by this package.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies
     (the browser has a menu function for that)"

    ^ #(
        #'stx:goodies/petitparser'    "PPAbstractParseTest - superclass of JavaParserIITests "
        #'stx:goodies/sunit'    "TestAsserter - superclass of JavaParserIITests "
        #'stx:libbasic'    "Autoload - superclass of JavaSourcePartitioner "
        #'stx:libcomp'    "ParseNode - superclass of JavaAnnotationDeclarationNode "
        #'stx:libjava'    "JavaObject - extended "
        #'stx:libtool'    "AbstractSettingsApplication - superclass of JavaSettingsApplication "
        #'stx:libview'    "DeviceGraphicsContext - superclass of JavaListInspectorView "
        #'stx:libview2'    "ApplicationModel - extended "
        #'stx:libwidg2'    "HierarchicalItem - superclass of JavaCodeBundleEditor::Item "
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'squeak:petitparser'
        #'stx:goodies/petitparser'    "PPCompositeParser - superclass of JavaSyntaxHighlighter::Parser "
        #'stx:goodies/sunit'
        #'stx:libbasic'    "Stream - superclass of JavaParser_Old::LineNumberStream "
        #'stx:libbasic2'    "CacheDictionary - referenced by JavaParser_Eclipse class>>initialize "
        #'stx:libcomp'    "ParseNode - superclass of JavaCharTypeNode "
        #'stx:libjava'    "JavaBehavior - superclass of extended JavaClass "
        #'stx:libtool'    "SetInspectorView - superclass of JavaSetInspectorView "
        #'stx:libview'    "GraphicsMedium - superclass of JavaMapInspectorView "
        #'stx:libview2'    "ApplicationModel - superclass of JavaSettingsApplication "
        #'stx:libwidg'    "GenericToolbarIconLibrary - extended "
    )
!

referencedPreRequisites
    "list all packages containing classes referenced by the packages's members.
     This list can be maintained manually or (better) generated and
     updated by looking for global variable accesses
     (the browser has a menu function for that)
     However, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPreRequisites method."

    ^ #(
        #'jv:smallsense'    "SmallSense::ParseNodeInspector - referenced by JavaSourceDocument>>inspector2TabParseTree "
        #'stx:libbasic2'    "CacheDictionary - referenced by JavaParser_Eclipse class>>initialize "
        #'stx:libjava/experiments'    "JavaCompiler - referenced by JavaCompilerProblemService>>syntaxHighlighter "
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
    )
! !

!stx_libjava_tools class methodsFor:'description - compilation'!

additionalRules_bc_dot_mak
    ^ '
java: ant

ant:
        ant -f java\build.xml dependencies build

antIfPossible:
        -ant -f java\build.xml dependencies build

full::  ant
'

    "Modified: / 17-04-2013 / 19:15:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalRules_make_dot_proto
    ^ '
java: ant

ant:
        ant -f java/build.xml dependencies build

antIfPossible:
        -ant -f java/build.xml dependencies build

full::  ant
'

    "Modified: / 17-04-2013 / 19:16:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalTargets_bc_dot_mak

    ^ ' antIfPossible'

    "Modified: / 17-04-2013 / 19:16:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalTargets_make_dot_proto

    ^ ' antIfPossible'

    "Created: / 05-09-2006 / 16:05:12 / cg"
    "Modified: / 17-04-2013 / 19:16:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libjava_tools class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        JavaCodeBundleEditor
        JavaCodeLibraryEditor
        JavaCompilerProblemHighlighter
        JavaCompilerProblemPopup
        JavaCompilerProblemService
        JavaListInspectorView
        JavaMapInspectorView
        JavaParseNode
        JavaParseNodeBuilder
        JavaParserI
        (JavaParserIITests autoload)
        (JavaParserITests autoload)
        #'JavaParser_Eclipse'
        JavaScannerBase
        JavaSetInspectorView
        JavaSettingsApplication
        JavaSourceDocument
        JavaSourcePartition
        (JavaSourcePartitioner autoload)
        (JavaSourcePartitionerTests autoload)
        JavaSourceReference
        (#'JavaSyntaxHighlighter_Eclipse' autoload)
        (#'JavaSyntaxHighlighter_Old' autoload)
        JavaToolbox
        #'stx_libjava_tools'
        JavaDeclarationNode
        JavaImportDeclarationNode
        JavaLiteralNode
        JavaPackageDeclarationNode
        JavaParserII
        JavaScanner
        JavaSourceFile
        JavaMethodLikeDeclarationNode
        JavaParser
        JavaTypeDeclarationNode
        JavaVariableDeclarationNode
        JavaAnnotationDeclarationNode
        JavaClassDeclarationNode
        JavaConstructorDeclarationNode
        JavaEnumDeclarationNode
        JavaInterfaceDeclarationNode
        JavaMethodDeclarationNode
        JavaSourceHighlighter
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        JavaObject inspectorClass
        #'Tools::NewSystemBrowser' classMenuNewGroovyClass
        'ConfigurableFeatures class' hasGroovySupport
        'ConfigurableFeatures class' hasJavaToolingSupport
    )
! !

!stx_libjava_tools class methodsFor:'description - java'!

javaBundle

    ^JavaCodeBundle standardPackageBundleFor: self package

    "Created: / 15-01-2013 / 17:35:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libjava_tools class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
!

stcOptimizationOptions
    "do not inline the not operation here - it is overwritten"

    ^ '+optspace3 -inlinenot'

    "Created: / 23-08-2006 / 01:27:22 / cg"
! !

!stx_libjava_tools class methodsFor:'description - svn'!

svnRepositoryUrlString
    "Return a SVN repository URL of myself.
     (Generated since 2011-04-08)
     Do not make the string shorter!!!!!! We have to use fixed-length keyword!!!!!!
    "        

    ^ '$URL::                                                                                                                        $'
!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"'1941            '"$"
! !

!stx_libjava_tools class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjava/tools/stx_libjava_tools.st,v 1.4 2013-09-06 00:45:28 vrany Exp $'
!

version_HG

    ^ '$Changeset: <not expanded> $'
!

version_SVN
    ^ 'Id'
! !

